diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/src/main/java/net/minecraft/client/render/block/model/LeverBlockModel.java
similarity index 58%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
rename to src/main/java/net/minecraft/client/render/block/model/LeverBlockModel.java
index 3ba77f047..f66b7a892 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LeverBlockModel.java
@@ -1,15 +1,16 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 
-public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
-    public BlockModelLever(Block block) {
+public class LeverBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public LeverBlockModel(Block block) {
         super(block);
     }
 
@@ -22,7 +23,7 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
         boolean flag1 = renderBlocks.overrideBlockTexture != null;
         if(!flag1)
         {
-            renderBlocks.overrideBlockTexture = BlockModelDispatcher.getInstance().getDispatch(Block.cobbleStone).getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
+            renderBlocks.overrideBlockTexture = BlockModelDispatcher.getInstance().getDispatch(Blocks.COBBLE_STONE).getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
         }
         float f = 0.25F;
         float f1 = 0.1875F;
@@ -78,73 +79,73 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
         double f5 = texture.getIconUMax();
         double f6 = texture.getIconVMin();
         double f7 = texture.getIconVMax();
-        Vec3d[] avec3d = new Vec3d[8];
+        Vec3[] avec3 = new Vec3[8];
         float f8 = 0.0625F;
         float f9 = 0.0625F;
         float f10 = 0.625F;
-        avec3d[0] = Vec3d.createVector(-f8, 0.0D, -f9);
-        avec3d[1] = Vec3d.createVector(f8, 0.0D, -f9);
-        avec3d[2] = Vec3d.createVector(f8, 0.0D, f9);
-        avec3d[3] = Vec3d.createVector(-f8, 0.0D, f9);
-        avec3d[4] = Vec3d.createVector(-f8, f10, -f9);
-        avec3d[5] = Vec3d.createVector(f8, f10, -f9);
-        avec3d[6] = Vec3d.createVector(f8, f10, f9);
-        avec3d[7] = Vec3d.createVector(-f8, f10, f9);
+        avec3[0] = Vec3.getTempVec3(-f8, 0.0D, -f9);
+        avec3[1] = Vec3.getTempVec3(f8, 0.0D, -f9);
+        avec3[2] = Vec3.getTempVec3(f8, 0.0D, f9);
+        avec3[3] = Vec3.getTempVec3(-f8, 0.0D, f9);
+        avec3[4] = Vec3.getTempVec3(-f8, f10, -f9);
+        avec3[5] = Vec3.getTempVec3(f8, f10, -f9);
+        avec3[6] = Vec3.getTempVec3(f8, f10, f9);
+        avec3[7] = Vec3.getTempVec3(-f8, f10, f9);
         for(int i2 = 0; i2 < 8; i2++)
         {
             if(flag)
             {
-                avec3d[i2].zCoord -= 0.0625D;
-                avec3d[i2].rotateAroundX(0.6981317F);
+                avec3[i2].z -= 0.0625D;
+                avec3[i2].rotateAroundX(0.6981317F);
             } else
             {
-                avec3d[i2].zCoord += 0.0625D;
-                avec3d[i2].rotateAroundX(-0.6981317F);
+                avec3[i2].z += 0.0625D;
+                avec3[i2].rotateAroundX(-0.6981317F);
             }
             if(i1 == 6 || i1 == 8)
             {
-                avec3d[i2].rotateAroundY(MathHelper.PI/2f);
+                avec3[i2].rotateAroundY(MathHelper.PI/2f);
             }
             if(i1 < 5)
             {
-                avec3d[i2].yCoord -= 0.375D;
-                avec3d[i2].rotateAroundX(MathHelper.PI/2f);
+                avec3[i2].y -= 0.375D;
+                avec3[i2].rotateAroundX(MathHelper.PI/2f);
                 if(i1 == 4)
                 {
-                    avec3d[i2].rotateAroundY(0.0F);
+                    avec3[i2].rotateAroundY(0.0F);
                 }
                 if(i1 == 3)
                 {
-                    avec3d[i2].rotateAroundY(MathHelper.PI);
+                    avec3[i2].rotateAroundY(MathHelper.PI);
                 }
                 if(i1 == 2)
                 {
-                    avec3d[i2].rotateAroundY(MathHelper.PI/2f);
+                    avec3[i2].rotateAroundY(MathHelper.PI/2f);
                 }
                 if(i1 == 1)
                 {
-                    avec3d[i2].rotateAroundY(-MathHelper.PI/2f);
+                    avec3[i2].rotateAroundY(-MathHelper.PI/2f);
                 }
-                avec3d[i2].xCoord += (double)x + 0.5D;
-                avec3d[i2].yCoord += (float)y + 0.5F;
-                avec3d[i2].zCoord += (double)z + 0.5D;
+                avec3[i2].x += (double)x + 0.5D;
+                avec3[i2].y += (float)y + 0.5F;
+                avec3[i2].z += (double)z + 0.5D;
             } else if (i1 == 5 || i1 == 6)
             {
-                avec3d[i2].xCoord += (double)x + 0.5D;
-                avec3d[i2].yCoord += (float)y + 0.125F;
-                avec3d[i2].zCoord += (double)z + 0.5D;
+                avec3[i2].x += (double)x + 0.5D;
+                avec3[i2].y += (float)y + 0.125F;
+                avec3[i2].z += (double)z + 0.5D;
             } else {
-                avec3d[i2].rotateAroundX(MathHelper.PI);
-                avec3d[i2].xCoord += (double)x + 0.5D;
-                avec3d[i2].yCoord += (float)(y + 1) - 0.125F;
-                avec3d[i2].zCoord += (double)z + 0.5D;
+                avec3[i2].rotateAroundX(MathHelper.PI);
+                avec3[i2].x += (double)x + 0.5D;
+                avec3[i2].y += (float)(y + 1) - 0.125F;
+                avec3[i2].z += (double)z + 0.5D;
             }
         }
 
-        Vec3d vec3d;
-        Vec3d vec3d1;
-        Vec3d vec3d2;
-        Vec3d vec3d3;
+        Vec3 vec3;
+        Vec3 vec31;
+        Vec3 vec32;
+        Vec3 vec3d3;
         for(int j2 = 0; j2 < 6; j2++)
         {
             if(j2 == 0)
@@ -163,48 +164,48 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
             }
             if(j2 == 0)
             {
-                vec3d = avec3d[0];
-                vec3d1 = avec3d[1];
-                vec3d2 = avec3d[2];
-                vec3d3 = avec3d[3];
+                vec3 = avec3[0];
+                vec31 = avec3[1];
+                vec32 = avec3[2];
+                vec3d3 = avec3[3];
             } else
             if(j2 == 1)
             {
-                vec3d = avec3d[7];
-                vec3d1 = avec3d[6];
-                vec3d2 = avec3d[5];
-                vec3d3 = avec3d[4];
+                vec3 = avec3[7];
+                vec31 = avec3[6];
+                vec32 = avec3[5];
+                vec3d3 = avec3[4];
             } else
             if(j2 == 2)
             {
-                vec3d = avec3d[1];
-                vec3d1 = avec3d[0];
-                vec3d2 = avec3d[4];
-                vec3d3 = avec3d[5];
+                vec3 = avec3[1];
+                vec31 = avec3[0];
+                vec32 = avec3[4];
+                vec3d3 = avec3[5];
             } else
             if(j2 == 3)
             {
-                vec3d = avec3d[2];
-                vec3d1 = avec3d[1];
-                vec3d2 = avec3d[5];
-                vec3d3 = avec3d[6];
+                vec3 = avec3[2];
+                vec31 = avec3[1];
+                vec32 = avec3[5];
+                vec3d3 = avec3[6];
             } else
             if(j2 == 4)
             {
-                vec3d = avec3d[3];
-                vec3d1 = avec3d[2];
-                vec3d2 = avec3d[6];
-                vec3d3 = avec3d[7];
+                vec3 = avec3[3];
+                vec31 = avec3[2];
+                vec32 = avec3[6];
+                vec3d3 = avec3[7];
             } else {
-                vec3d = avec3d[0];
-                vec3d1 = avec3d[3];
-                vec3d2 = avec3d[7];
-                vec3d3 = avec3d[4];
+                vec3 = avec3[0];
+                vec31 = avec3[3];
+                vec32 = avec3[7];
+                vec3d3 = avec3[4];
             }
-            tessellator.addVertexWithUV(vec3d.xCoord, vec3d.yCoord, vec3d.zCoord, f4, f7);
-            tessellator.addVertexWithUV(vec3d1.xCoord, vec3d1.yCoord, vec3d1.zCoord, f5, f7);
-            tessellator.addVertexWithUV(vec3d2.xCoord, vec3d2.yCoord, vec3d2.zCoord, f5, f6);
-            tessellator.addVertexWithUV(vec3d3.xCoord, vec3d3.yCoord, vec3d3.zCoord, f4, f6);
+            tessellator.addVertexWithUV(vec3.x, vec3.y, vec3.z, f4, f7);
+            tessellator.addVertexWithUV(vec31.x, vec31.y, vec31.z, f5, f7);
+            tessellator.addVertexWithUV(vec32.x, vec32.y, vec32.z, f5, f6);
+            tessellator.addVertexWithUV(vec3d3.x, vec3d3.y, vec3d3.z, f4, f6);
         }
 
         return true;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java b/src/main/java/net/minecraft/client/render/block/model/MossyStoneBlockModel.java
similarity index 91%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
rename to src/main/java/net/minecraft/client/render/block/model/MossyStoneBlockModel.java
index 055ae05f5..2d267ba97 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelMossyStone.java
+++ b/src/main/java/net/minecraft/client/render/block/model/MossyStoneBlockModel.java
@@ -1,16 +1,16 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelMossyStone<T extends Block> extends BlockModelStandard<T> {
+public class MossyStoneBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate mossOverlay;
-    public BlockModelMossyStone(Block block) {
+    public MossyStoneBlockModel(Block block) {
         super(block);
         mossOverlay = TextureRegistry.getTexture("minecraft:block/moss_overlay");
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelMotionSensor.java b/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
similarity index 61%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelMotionSensor.java
rename to src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
index cb8e5820f..2401550df 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelMotionSensor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockMotionSensor;
+import net.minecraft.core.block.MotionSensorBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelMotionSensor extends BlockModelHorizontalRotation<BlockMotionSensor> {
+public class MotionSensorBlockModel extends HorizontalRotationBlockModel<MotionSensorBlock> {
     protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/motionsensor_overlay");
-    public BlockModelMotionSensor(Block block) {
+    public MotionSensorBlockModel(Block block) {
         super(block);
     }
 
@@ -25,6 +25,6 @@ public class BlockModelMotionSensor extends BlockModelHorizontalRotation<BlockMo
     }
     @Override
     public boolean hasOverbright(){
-        return !block.isActive;
+        return block.isActive;
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/PaintedChestBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PaintedChestBlockModel.java
new file mode 100644
index 000000000..7461e32df
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/PaintedChestBlockModel.java
@@ -0,0 +1,86 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.ChestBlock;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+
+public class PaintedChestBlockModel<T extends Block> extends ChestBlockModel<T> {
+    public static final IconCoordinate[][] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT][];
+    public static final int TEX_SINGLE_FRONT = 0;
+    public static final int TEX_LEFT_FRONT = 1;
+    public static final int TEX_RIGHT_FRONT = 2;
+    public static final int TEX_LEFT_BACK = 3;
+    public static final int TEX_RIGHT_BACK = 4;
+    public static final int TEX_SIDE = 5;
+    public static final int TEX_TOP = 6;
+
+    static {
+        for (DyeColor c : DyeColor.blockOrderedColors()){
+            String rootKey = "minecraft:block/chest_planks_oak_painted_" + c.colorID;
+            texCoords[c.blockMeta] = new IconCoordinate[7];
+            texCoords[c.blockMeta][TEX_SINGLE_FRONT] = TextureRegistry.getTexture(rootKey + "_front");
+            texCoords[c.blockMeta][TEX_LEFT_FRONT] = TextureRegistry.getTexture(rootKey + "_left_front");
+            texCoords[c.blockMeta][TEX_RIGHT_FRONT] = TextureRegistry.getTexture(rootKey + "_right_front");
+            texCoords[c.blockMeta][TEX_LEFT_BACK] = TextureRegistry.getTexture(rootKey + "_left_back");
+            texCoords[c.blockMeta][TEX_RIGHT_BACK] = TextureRegistry.getTexture(rootKey + "_right_back");
+            texCoords[c.blockMeta][TEX_SIDE] = TextureRegistry.getTexture(rootKey + "_side");
+            texCoords[c.blockMeta][TEX_TOP] = TextureRegistry.getTexture(rootKey + "_top");
+        }
+    }
+    public PaintedChestBlockModel(Block block) {
+        super(block, "minecraft:block/chest_planks_oak");
+    }
+
+    @Override
+    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
+        int meta = blockAccess.getBlockMetadata(x, y, z);
+        int color = meta >> 4;
+
+        if(side == Side.TOP || side == Side.BOTTOM) {
+            return texCoords[color][6];
+        }
+
+        Side facing = ChestBlock.getDirectionFromMeta(meta).getSide();
+        ChestBlock.Type type = ChestBlock.getTypeFromMeta(meta);
+
+        if(type == ChestBlock.Type.SINGLE) {
+            if(side == facing) {
+                return texCoords[color][TEX_SINGLE_FRONT];
+            }
+        }
+        if(type == ChestBlock.Type.LEFT) {
+            if(side == facing) {
+                return texCoords[color][TEX_LEFT_FRONT];
+            }
+            if(side == facing.getOpposite()) {
+                return texCoords[color][TEX_RIGHT_BACK];
+            }
+        }
+        if(type == ChestBlock.Type.RIGHT) {
+            if(side == facing) {
+                return texCoords[color][TEX_RIGHT_FRONT];
+            }
+            if(side == facing.getOpposite()) {
+                return texCoords[color][TEX_LEFT_BACK];
+            }
+        }
+        if(side.getAxis() != Axis.Y) {
+            return texCoords[color][TEX_SIDE];
+        }
+
+        return texCoords[color][TEX_TOP];
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+        int color = data >> 4;
+        if (side == Side.SOUTH) return texCoords[color][TEX_SINGLE_FRONT];
+        if (side.isHorizontal()) return texCoords[color][TEX_SIDE];
+        return texCoords[color][TEX_TOP];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
new file mode 100644
index 000000000..66ddeb97c
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
@@ -0,0 +1,37 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.DoorBlock;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+
+public class PaintedDoorBlockModel<T extends DoorBlock> extends DoorBlockModel<T> {
+    public static final IconCoordinate[] doorBottomTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    public static final IconCoordinate[] doorTopTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+
+    static {
+        for (DyeColor c : DyeColor.blockOrderedColors()){
+            doorTopTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door_planks_oak_" + c.colorID + "_top");
+            doorBottomTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door_planks_oak_" + c.colorID + "_bottom");
+        }
+    }
+    private final boolean isTop;
+    public PaintedDoorBlockModel(Block block, boolean isTop) {
+        super(block);
+        this.isTop = isTop;
+    }
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    {
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
+        if (side.getAxis() == Axis.Y){
+            return TrapDoorPaintedBlockModel.topTextures[color];
+        } else if (isTop){
+            return doorTopTextures[color];
+        }
+        return doorBottomTextures[color];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java b/src/main/java/net/minecraft/client/render/block/model/PebblesBlockModel.java
similarity index 87%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
rename to src/main/java/net/minecraft/client/render/block/model/PebblesBlockModel.java
index a94e90297..9df336ece 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPebbles.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PebblesBlockModel.java
@@ -1,20 +1,20 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelPebbles<T extends Block> extends BlockModelStandard<T> {
+public class PebblesBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate[] pebbles = {
             TextureRegistry.getTexture("minecraft:block/pebbles0"),
             TextureRegistry.getTexture("minecraft:block/pebbles1"),
             TextureRegistry.getTexture("minecraft:block/pebbles2")
     };
-    public BlockModelPebbles(Block block) {
+    public PebblesBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
similarity index 91%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
rename to src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
index dff191a91..0aefb478a 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
@@ -1,20 +1,20 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.logic.PistonDirections;
-import net.minecraft.core.block.piston.BlockPistonBase;
+import net.minecraft.core.block.piston.BasePistonBlock;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStandard<T> {
+public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockModel<T> {
     private final IconCoordinate faceTexture;
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/piston_side");
     protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/piston_top");
     protected IconCoordinate bottomTexture = TextureRegistry.getTexture("minecraft:block/piston_bottom");
-    public BlockModelPiston(Block block, IconCoordinate faceTexture){
+    public PistonBlockModel(Block block, IconCoordinate faceTexture){
         super(block);
         this.faceTexture = faceTexture;
     }
@@ -33,7 +33,7 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
     protected boolean renderPistonBase(Tessellator tessellator, int i, int j, int k, boolean flag) {
         int l = renderBlocks.blockAccess.getBlockMetadata(i, j, k);
         boolean flag1 = flag || (l & 8) != 0;
-        int i1 = BlockPistonBase.getDirection(l);
+        int i1 = BasePistonBlock.getDirection(l);
         if(flag1)
         {
             switch(i1)
@@ -137,14 +137,14 @@ public class BlockModelPiston<T extends BlockPistonBase> extends BlockModelStand
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        int direction = BlockPistonBase.getDirection(data);
+        int direction = BasePistonBlock.getDirection(data);
         if (direction > 5)
         {
             return atlasIndices[0];
         }
         if (side.getId() == direction)
         {
-            if (BlockPistonBase.isPowered(data) || block.minX > 0.0D || block.minY > 0.0D || block.minZ > 0.0D || block.maxX < 1.0D || block.maxY < 1.0D || block.maxZ < 1.0D)
+            if (BasePistonBlock.isPowered(data) || block.minX > 0.0D || block.minY > 0.0D || block.minZ > 0.0D || block.maxX < 1.0D || block.maxY < 1.0D || block.maxZ < 1.0D)
             {
                 return topTexture;
             }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
similarity index 92%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
rename to src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
index 1590095f4..cee28d051 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
@@ -1,19 +1,22 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.logic.PistonDirections;
-import net.minecraft.core.block.piston.BlockPistonHead;
+import net.minecraft.core.block.piston.PistonHeadBlock;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
-public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
+public class PistonHeadBlockModel extends StandardBlockModel<PistonHeadBlock> {
     protected IconCoordinate pistonSide = TextureRegistry.getTexture("minecraft:block/piston_side");
     protected IconCoordinate pistonDry = TextureRegistry.getTexture("minecraft:block/piston_face");
     protected IconCoordinate pistonSticky = TextureRegistry.getTexture("minecraft:block/piston_face_sticky");
-    public BlockModelPistonHead(Block block) {
+    @Nullable
+    public IconCoordinate faceTextureOverride;
+    public PistonHeadBlockModel(Block block) {
         super(block);
     }
 
@@ -22,14 +25,17 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         return renderPistonHead(tessellator, block, x, y, z, true);
     }
-    public void renderPistonHeadNoCulling(Tessellator tessellator, BlockPistonHead block, int x, int y, int z, boolean flag) {
+    public void renderPistonHeadNoCulling(Tessellator tessellator, PistonHeadBlock block, int x, int y, int z, boolean flag) {
         renderBlocks.renderAllFaces = true;
         renderPistonHead(tessellator, block, x, y, z, flag);
         renderBlocks.renderAllFaces = false;
     }
-    protected boolean renderPistonHead(Tessellator tessellator, BlockPistonHead block, int x, int y, int z, boolean flag) {
+    public void setFaceTextureOverride(@Nullable IconCoordinate faceTexture){
+        faceTextureOverride = faceTexture;
+    }
+    protected boolean renderPistonHead(Tessellator tessellator, PistonHeadBlock block, int x, int y, int z, boolean flag) {
         int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        int direction = BlockPistonHead.getDirectionFromMeta(metadata);
+        int direction = PistonHeadBlock.getDirectionFromMeta(metadata);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
@@ -176,12 +182,12 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        int direction = BlockPistonHead.getDirectionFromMeta(data);
+        int direction = PistonHeadBlock.getDirectionFromMeta(data);
         if(side.getId() == direction)
         {
-            if(block.faceTexture != null)
+            if(faceTextureOverride != null)
             {
-                return block.faceTexture;
+                return faceTextureOverride;
             }
             if((data & 8) != 0)
             {
diff --git a/src/main/java/net/minecraft/client/render/block/model/PlanksPaintedBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PlanksPaintedBlockModel.java
new file mode 100644
index 000000000..26c0820fc
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/PlanksPaintedBlockModel.java
@@ -0,0 +1,26 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+
+public class PlanksPaintedBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+
+    static {
+        for (DyeColor c : DyeColor.blockOrderedColors()){
+            texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks_oak_painted_" + c.colorID);
+        }
+    }
+
+    public PlanksPaintedBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+        return texCoords[meta & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java b/src/main/java/net/minecraft/client/render/block/model/PortalBlockModel.java
similarity index 90%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
rename to src/main/java/net/minecraft/client/render/block/model/PortalBlockModel.java
index 103649faf..a3adb1a79 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PortalBlockModel.java
@@ -3,8 +3,8 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelPortal<T extends Block> extends BlockModelTransparent<T> {
-    public BlockModelPortal(Block block) {
+public class PortalBlockModel<T extends Block> extends TransparentBlockModel<T> {
+    public PortalBlockModel(Block block) {
         super(block, false);
     }
     @Override
